Attribute VB_Name = "IntrlaceStencil"
'generating the interlaced stancil content for stereo
'purpose, other pattern could be used for lenticular
'stereo displays

Public Sub interlace_stencil(gliWindowWidth As GLint, gliWindowHeight As GLint)

    Dim gliY As GLint
    ' seting screen-corresponding geometry
    glViewport 0, 0, gliWindowWidth, gliWindowHeight
    glMatrixMode GL_MODELVIEW
    glLoadIdentity
    glMatrixMode GL_PROJECTION
    glLoadIdentity
    gluOrtho2D 0#, gliWindowWidth - 0.32, 0#, gliWindowHeight - 0.32
    glMatrixMode GL_MODELVIEW
    glLoadIdentity
        
    ' clearing and configurating stencil drawing
    glDrawBuffer GL_BACK
    glEnable GL_STENCIL_TEST
    glClearStencil 0
    glClear GL_STENCIL_BUFFER_BIT
    glStencilOp GL_REPLACE, GL_REPLACE, GL_REPLACE ' colorbuffer is copied to stencil
    glDisable GL_DEPTH_TEST
    glStencilFunc GL_ALWAYS, 1, 1 ' to avoid interaction with stencil content
    
    ' drawing stencil pattern
    glColor4f 1, 1, 1, 0 ' alfa is 0 not to interfere with alpha tests
    glLineWidth 1
    For gliY = 0 To gliWindowHeight Step 2
        glBegin GL_LINES
            glVertex2f 0, gliY
            glVertex2f gliWindowWidth, gliY
        glEnd
    Next gliY
    glStencilOp GL_KEEP, GL_KEEP, GL_KEEP ' disabling changes in stencil buffer
    glFlush
End Sub
