Attribute VB_Name = "GLgeometrickeobjekty"
' pre definition of standard objects (names in Czech language)
' not all used by MCE
Option Explicit
Sub CentrovanaKrychle(a As Double)
 ' centered cube
    CentrovanyKvadr a, a, a
 End Sub
 Sub CentrovanyKvadr(a As Double, b As Double, c As Double)
 ' Kvadr se stredem v 0,0,0
     glTranslatef -a / 2, -b / 2, -c / 2
    Kvadr a, b, c
    glTranslatef a / 2, b / 2, c / 2
 End Sub
 Sub LineKvadr(a As Double, b As Double, c As Double)
 
 'predni strana
 glBegin GL_LINE_LOOP
 glVertex3f 0, 0, 0
 glVertex3f a, 0, 0
 glVertex3f a, b, 0
 glVertex3f 0, b, 0
 glEnd
 
 'zadni strana
 glBegin GL_LINE_LOOP
 glVertex3f 0, 0, c
 glVertex3f a, 0, c
 glVertex3f a, b, c
 glVertex3f 0, b, c
 glEnd
 
 'spojeni
 glBegin GL_LINES
 
 glVertex3f 0, 0, 0
 glVertex3f 0, 0, c
 glVertex3f a, 0, 0
 glVertex3f a, 0, c
 glVertex3f a, b, 0
 glVertex3f a, b, c
 glVertex3f 0, b, 0
 glVertex3f 0, b, c
 
 glEnd
 
 End Sub
 
 
 Sub Kvadr(a As Double, b As Double, c As Double)
 ' Krychle portovana z C cka
 ' bod 0,0,0 Kvadru v 0,0,0 GL
  glBegin GL_QUADS
 
    glNormal3f 0#, 0#, -1
    'glTexCoord2f 0#, 0#:
    glVertex3f 0#, 0#, 0#:
    'glTexCoord2f 1#, 0#:
    glVertex3f a#, 0#, 0#:
    'glTexCoord2f 1#, 1#:
    glVertex3f a#, b#, 0#:
    'glTexCoord2f 0#, 1#:
    glVertex3f 0#, b#, 0#:

    glNormal3f 0#, 0#, 1#:
    'glTexCoord2f 0#, 0#:
    glVertex3f 0#, 0#, c#:
    'glTexCoord2f 1#, 0#:
    glVertex3f a#, 0#, c#:
    'glTexCoord2f 1#, 1#:
    glVertex3f a#, b#, c#:
    'glTexCoord2f 0#, 1#:
    glVertex3f 0#, b#, c#:

    glNormal3f 0#, 1#, 0#:
    'glTexCoord2f 0#, 0#:
    glVertex3f 0#, b#, 0#:
    'glTexCoord2f 1#, 0#:
    glVertex3f a#, b#, 0#:
    'glTexCoord2f 1#, 1#:
    glVertex3f a#, b#, c#:
    'glTexCoord2f 0#, 1#:
    glVertex3f 0#, b#, c#:

    glNormal3f 0#, -1#, 0#:
    'glTexCoord2f 0#, 0#:
    glVertex3f 0#, 0#, 0#:
    'glTexCoord2f 1#, 0#:
    glVertex3f a#, 0#, 0#:
    'glTexCoord2f 1#, 1#:
    glVertex3f a#, 0#, c#:
    'glTexCoord2f 0#, 1#:
    glVertex3f 0#, 0#, c#:

    glNormal3f 1#, 0#, 0#:
    'glTexCoord2f 0#, 0#:
    glVertex3f a#, 0#, 0#:
    'glTexCoord2f 1#, 0#:
    glVertex3f a#, b#, 0#:
    'glTexCoord2f 1#, 1#:
    glVertex3f a#, b#, c#:
    'glTexCoord2f 0#, 1#:
    glVertex3f a#, 0#, c#:

    glNormal3f -1#, 0#, 0#:
    'glTexCoord2f 0#, 0#:
    glVertex3f 0#, 0#, 0#:
    'glTexCoord2f 1#, 0#:
    glVertex3f 0#, b#, 0#:
    'glTexCoord2f 1#, 1#:
    glVertex3f 0#, b#, c#:
    'glTexCoord2f 0#, 1#:
    glVertex3f 0#, 0#, c#:
    glEnd

 End Sub
 
 
 Sub Koule(objekt As GLUquadric, polomer, kvalita)
    gluSphere objekt, polomer, kvalita, kvalita
 End Sub
 
 Sub Valec(objekt As GLUquadric, podstava, delka, kvalita)
    gluCylinder objekt, podstava, podstava, delka, kvalita, kvalita
 End Sub
 
Sub Triangle(x1 As Single, y1 As Single, z1 As Single, x2 As Single, y2 As Single, z2 As Single, X3 As Single, Y3 As Single, Z3 As Single)
Dim N1 As Single, N2 As Single, N3 As Single

glBegin GL_TRIANGLES
    
   ' Normal X1, Y1, Z1, X2, Y2, Z2, X3, Y3, Z3, N1, N2, N3 'nutny modul normalizace

    glNormal3f N1, N2, N3
    
    glVertex3f x1, y1, z1
    glVertex3f x2, y2, z2
    glVertex3f X3, Y3, Z3

glEnd
End Sub

